Page MenuHomePhabricator

Wrap-up report for "Newsletter extension for MediaWiki"
Closed, ResolvedPublic

Description

Project Description

Many Wikimedia projects and developers use newsletters to broadcast recent developments or any set of relevant news to other Wikimedians. But having to find a newsletter main page out of all the wikis and then subscribing to it by adding your username to a wiki page doesn't really sound appealing. That's when @Qgil thought of centralizing the functions of all newsletters at one place, an idea which later shaped to an extension, Newsletter extension.

My only motivation for the centralization is the need to offer a catalog with all the newsletters available in a wiki farm, and the possibility to subscribe/unsubscribe and receive notifications without having to visit or be an active editor of any wiki. If we solve these use cases, then I agree that each wiki community should be able to manage their own newsletters.

Take a look at our project!

So, assuming you are a user who has an account in whichever wiki you are associated with let's start exploring the Newsletter extension. Newsletter extension has three Special pages related to it :

  • Special:Newsletters - If you go to Special:SpecialPages, under the 'Other Pages' section there is a link titled 'Newsletters' which leads you to a page where you can subscribe/unsubscribe to various newsletters. On this page you can see a table which gives you an overview of all the newsletters in the wiki. You can subscribe or unsubscribe from the newsletters just by checking the corresponding radio buttons.
  • Special:NewsletterCreate - If you go to Special:SpecialPages, under the 'Other Pages' section there is a link titled 'Create newsletters' which leads you to a special page that helps you to create newsletters. To create a newsletter, you are required to be prepared with a wiki page which will serve as you newsletter's main page and then there are other fields to fill out details of your new newsletter like name of the newsletter, frequency at which issues will be published etc.
  • Special:NewsletterManage - If you go to Special:SpecialPages, under the 'Other Pages' section there is a link titled 'Manage newsletters' which leads you to a special page that helps you to manage newsletters owned by you.
    This page caters as platform to:
    • Add publishers - Under the 'Add publishers' section, you can add new publishers( those who can announce issues ) for your newsletters. Only fields required are name of the newsletter and username of the publisher.
    • Remove publishers - On this page a table can be seen which gives a detailed view of the newsletters with columns listing the contributors, permissions of the contributors and a column with a 'Remove' button to remove a publisher( Note: Only an owner of a newsletter can remove a publisher of his newsletter )
    • Announce new issues - On the same page, under the 'Announce new issue' section you can announce new issues for your newsletters. Just like in 'Create Newsletters', you are required to be prepared with a page which will serve as you issue's main page. Notifications are send to subscribers when an issue is announced.

Newsletter extension uses the Echo extension to send out notifications to subscribed users whenever a newsletter announces a new upcoming issue.

Post GSoC for Newsletter extension

We have so much planned for Newsletter extension. All task in the 'Backlog' column of MediaWiki-extensions-Newsletter board are to be completed before the newsletter extension goes in production. I along with @Qgil and @01tonythomas carefully plan tasks to be done for every week on our weekly meetings and the remaining tasks are the ones we left for post GSoC.

Demo server

http://newsletter-test.wmflabs.org/

Resource links

About me

I'm Tina Johnson, an undergraduate student hailing from Kerala, a state in the south west region of India. I'm a member of the FOSS club of my university since my freshman year and that's how I was introduced to Open Source. I contribute to open source because it empowers me to help build software which one way or the other empowers others.

I was particularly interested in the Newsletter extension project because I realized this project would require a lot of UIs and also good ones because quite a number of people will be using it. I believe producing a responsive and user interactive interface is an art :) Once the GSoC coding period started, I started working on random tasks and eventually ended up working on nothing. That's when both my mentors, @Qgil and @01tonythomas made their glorious entrance. @Qgil is 'Da Boss' when it comes to planning and coordinating and @01tonythomas kept proving how he has turned into a full fledged MediaWiki developer. Developing this extension has been a great learning experience and how I wish to replace the software engineering lectures in university curriculums with GSoC :) And yes, I plan to continue contributing to MediaWiki, how can I leave a community so awesome ?

Event Timeline

Niharika created this task.Aug 17 2015, 1:39 PM
Niharika assigned this task to Tinaj1234.
Niharika raised the priority of this task from to Medium.
Niharika updated the task description. (Show Details)
Niharika added subscribers: Aklapper, Niharika, Sitic and 3 others.
Tinaj1234 updated the task description. (Show Details)Aug 21 2015, 6:06 PM
Dzahn added a subscriber: Dzahn.Aug 21 2015, 6:10 PM

I'm wondering if mailman/a list server is already serving this purpose since it's a central place to send mails to lists of people.

I'm wondering if mailman/a list server is already serving this purpose since it's a central place to send mails to lists of people.

This extension offers the option of being notified of new editions of a newsletter, directly on the wiki (and/or via email), without the overhead of needing to subscribe to an email-list (nor the obligation to have an email attached to one's account). Here are 2 quick screengrabs from the test instance: https://i.imgur.com/BuK9KL3.png and https://i.imgur.com/Ic6tdPj.png

By centralizing the location that everyone goes to read the instance of a newsletter, we'll also be implicitly enabling a more centralized feedback location, as every newsletter can thence be discussed on its own talkpage.

Tinaj1234 updated the task description. (Show Details)Aug 22 2015, 8:25 AM
Tinaj1234 updated the task description. (Show Details)Aug 22 2015, 9:12 AM
Tinaj1234 updated the task description. (Show Details)
Tinaj1234 updated the task description. (Show Details)Aug 23 2015, 9:51 AM
Qgil added a comment.Aug 24 2015, 8:21 AM

@Tinaj1234, thank you, this is a wrap-up post already good enough for the GSoC evaluation.

Now, if you want to improve it...

A little detail: I would list Special:Newsletters first, since this is the first interface users will see.

A bigger detail: you are reporting about your software, but... what about you? These wrap-up posts become a lot more useful and entertaining when developers share details that cannot be see in the source code and UI. :) Who were you before GSoC started? Why did you find this project interesting? What have you learned? Good, bad surprises? Your thought about Wikimedia tech, and your next steps in this community?

You don't have to write a confession and, as said, the post is already good for ticking its evaluation box. But in case you want to share more details for current and potential Wikimedia contributors...

And regardless, Big Thank You Tina for all your work.

Qgil awarded a token.Aug 24 2015, 8:22 AM

Now, if you want to improve it...

Sure! I'll just add the ones you mentioned.

And regardless, Big Thank You Tina for all your work.

Thank you for all the coordination and support. And thank you, @01tonythomas for all the awesome ideas.

Tinaj1234 updated the task description. (Show Details)Aug 24 2015, 2:05 PM
Qgil added a comment.Aug 25 2015, 8:50 AM

(me blushes) :)

This is ready to go. Thank you!

Qgil closed this task as Resolved.Aug 28 2015, 10:43 AM